/* Exports for assembly files.
   All C exports should go in the respective C files. */

#include <linux/module.h>
#include <linux/smp.h>

#include <asm/semaphore.h>
#include <asm/processor.h>
#include <asm/uaccess.h>
#include <asm/pgtable.h>

EXPORT_SYMBOL(kernel_thread);

EXPORT_SYMBOL(__down_failed);
EXPORT_SYMBOL(__down_failed_interruptible);
EXPORT_SYMBOL(__down_failed_trylock);
EXPORT_SYMBOL(__up_wakeup);

EXPORT_SYMBOL(__get_user_1);
EXPORT_SYMBOL(__get_user_2);
EXPORT_SYMBOL(__get_user_4);
EXPORT_SYMBOL(__get_user_8);
EXPORT_SYMBOL(__put_user_1);
EXPORT_SYMBOL(__put_user_2);
EXPORT_SYMBOL(__put_user_4);
EXPORT_SYMBOL(__put_user_8);

EXPORT_SYMBOL(copy_user_generic);
EXPORT_SYMBOL(copy_from_user);
EXPORT_SYMBOL(copy_to_user);

EXPORT_SYMBOL(copy_page);
EXPORT_SYMBOL(clear_page);

#ifdef CONFIG_SMP
extern void FASTCALL( __write_lock_failed(rwlock_t *rw));
extern void FASTCALL( __read_lock_failed(rwlock_t *rw));
EXPORT_SYMBOL(__write_lock_failed);
EXPORT_SYMBOL(__read_lock_failed);
#endif

/* Export string functions. We normally rely on gcc builtin for most of these,
   but gcc sometimes decides not to inline them. */    
#undef memcpy
#undef memset
#undef memmove

extern void * memset(void *,int,__kernel_size_t);
extern void * memcpy(void *,const void *,__kernel_size_t);
extern void * __memcpy(void *,const void *,__kernel_size_t);

EXPORT_SYMBOL(memset);
EXPORT_SYMBOL(memcpy);
EXPORT_SYMBOL(__memcpy);

EXPORT_SYMBOL(empty_zero_page);
EXPORT_SYMBOL(init_level4_pgt);
EXPORT_SYMBOL(load_gs_index);

#ifdef CONFIG_RETPOLINE
#define EXPORT_THUNK(reg)					\
	extern asmlinkage void __x86_indirect_thunk_##reg(void);\
	EXPORT_SYMBOL(__x86_indirect_thunk_##reg)

EXPORT_THUNK(rax);
EXPORT_THUNK(rbx);
EXPORT_THUNK(rcx);
EXPORT_THUNK(rdx);
EXPORT_THUNK(rsi);
EXPORT_THUNK(rdi);
EXPORT_THUNK(rbp);
EXPORT_THUNK(r8);
EXPORT_THUNK(r9);
EXPORT_THUNK(r10);
EXPORT_THUNK(r11);
EXPORT_THUNK(r12);
EXPORT_THUNK(r13);
EXPORT_THUNK(r14);
EXPORT_THUNK(r15);
#endif /* CONFIG_RETPOLINE */
